# Originally created by Spruce Studios (Random Dungeon Algorithm) https://modrinth.com/user/SpruceStudios

## Clear generation
# Empty rooms
execute at @e[tag=dun.room] run fill ~-8 ~-4 ~-8 ~8 ~30 ~8 minecraft:air
# Kill markers
kill @e[tag=dun.room]

## Summon room centers
# Main room (camp)
summon minecraft:marker 0 0 0 {Tags:["dun.room","dun.camp"]}
# 1st ring
function dun:generate/rings/one
# 2nd ring
function dun:generate/rings/two
# 2nd ring
function dun:generate/rings/three

## Generate empty rooms
# Empty rooms
execute at @e[tag=dun.room] run fill ~-8 ~-4 ~-8 ~8 ~30 ~8 minecraft:air
# Generate room template
execute at @e[tag=dun.room] run function dun:generate/empty

## Give each room its own id
function dun:roomid