# Originally created by Spruce Studios (Random Dungeon Algorithm) https://modrinth.com/user/SpruceStudios

tellraw @a {"text":"Loaded all dungeon rows","color":"green"}
kill @e[tag=dun.roomid]

## Generate default rooms
execute at @e[tag=dun.camp] run function dun:generate/camp

## Generate default doorways
# Camp
execute at @e[tag=dun.camp] run function dun:generate/exits/south
execute at @e[tag=dun.camp] run function dun:generate/exits/north-b
execute at @e[tag=dun.camp] run function dun:generate/exits/east-b
execute at @e[tag=dun.camp] run function dun:generate/exits/west-b
# One room south of camp
execute at @e[scores={dun.roomid=24}] run function dun:generate/exits/north
execute at @e[scores={dun.roomid=24}] run function dun:generate/exits/south
execute at @e[scores={dun.roomid=24}] run function dun:generate/exits/east
execute at @e[scores={dun.roomid=24}] run function dun:generate/exits/west

## Walls around the entire map (so no exits lead outwards into no room)
# First row (1-7)
execute at @e[scores={dun.roomid=1}] run function dun:generate/exits/south-b
execute at @e[scores={dun.roomid=1}] run function dun:generate/exits/west-b
execute at @e[scores={dun.roomid=2}] run function dun:generate/exits/west-b
execute at @e[scores={dun.roomid=3}] run function dun:generate/exits/west-b
execute at @e[scores={dun.roomid=4}] run function dun:generate/exits/west-b
execute at @e[scores={dun.roomid=5}] run function dun:generate/exits/west-b
execute at @e[scores={dun.roomid=6}] run function dun:generate/exits/west-b
execute at @e[scores={dun.roomid=7}] run function dun:generate/exits/north-b
execute at @e[scores={dun.roomid=7}] run function dun:generate/exits/west-b
# Bottom row (8, 15, 22, 29, 36)
execute at @e[scores={dun.roomid=8}] run function dun:generate/exits/south-b
execute at @e[scores={dun.roomid=15}] run function dun:generate/exits/south-b
execute at @e[scores={dun.roomid=22}] run function dun:generate/exits/south-b
execute at @e[scores={dun.roomid=29}] run function dun:generate/exits/south-b
execute at @e[scores={dun.roomid=36}] run function dun:generate/exits/south-b
# Top row (14, 21, 28, 35, 42)
execute at @e[scores={dun.roomid=14}] run function dun:generate/exits/north-b
execute at @e[scores={dun.roomid=21}] run function dun:generate/exits/north-b
execute at @e[scores={dun.roomid=28}] run function dun:generate/exits/north-b
execute at @e[scores={dun.roomid=35}] run function dun:generate/exits/north-b
execute at @e[scores={dun.roomid=42}] run function dun:generate/exits/north-b
# Last row (43-49)
execute at @e[scores={dun.roomid=43}] run function dun:generate/exits/south-b
execute at @e[scores={dun.roomid=43}] run function dun:generate/exits/east-b
execute at @e[scores={dun.roomid=44}] run function dun:generate/exits/east-b
execute at @e[scores={dun.roomid=45}] run function dun:generate/exits/east-b
execute at @e[scores={dun.roomid=46}] run function dun:generate/exits/east-b
execute at @e[scores={dun.roomid=47}] run function dun:generate/exits/east-b
execute at @e[scores={dun.roomid=48}] run function dun:generate/exits/east-b
execute at @e[scores={dun.roomid=49}] run function dun:generate/exits/north-b
execute at @e[scores={dun.roomid=49}] run function dun:generate/exits/east-b

## Pathfinding
function dun:pathfind

## Generate custom rooms
# Exit
function dun:furthestroom
execute at @e[tag=dun.furthest] run function dun:generate/exit