# Originally created by Spruce Studios (Random Dungeon Algorithm) https://modrinth.com/user/SpruceStudios

## Generate base room
# Walls
fill ~-8 ~ ~-8 ~8 ~9 ~8 minecraft:gray_terracotta
fill ~-7 ~ ~-7 ~7 ~9 ~7 minecraft:air
# Floor
fill ~-8 ~-1 ~-8 ~8 ~-2 ~8 minecraft:gray_terracotta
fill ~-5 ~-1 ~-6 ~5 ~-1 ~6 minecraft:stone_bricks
fill ~-6 ~-1 ~-5 ~6 ~-1 ~5 minecraft:stone_bricks
# Pillars
fill ~7 ~ ~7 ~7 ~9 ~7 minecraft:stone_bricks
fill ~-7 ~ ~-7 ~-7 ~9 ~-7 minecraft:stone_bricks
fill ~-7 ~ ~7 ~-7 ~9 ~7 minecraft:stone_bricks
fill ~7 ~ ~-7 ~7 ~9 ~-7 minecraft:stone_bricks
# Pillar bases
setblock ~6 ~ ~7 stone_brick_stairs[facing=east]
setblock ~7 ~ ~6 stone_brick_stairs[facing=south]
setblock ~-7 ~ ~6 stone_brick_stairs[facing=south]
setblock ~-6 ~ ~7 stone_brick_stairs[facing=west]
setblock ~6 ~ ~-7 stone_brick_stairs[facing=east]
setblock ~7 ~ ~-6 stone_brick_stairs[facing=north]
setblock ~-7 ~ ~-6 stone_brick_stairs[facing=north]
setblock ~-6 ~ ~-7 stone_brick_stairs[facing=west]
# Pillar tops
setblock ~6 ~8 ~7 stone_brick_stairs[facing=east,half=top]
setblock ~7 ~8 ~6 stone_brick_stairs[facing=south,half=top]
setblock ~-7 ~8 ~6 stone_brick_stairs[facing=south,half=top]
setblock ~-6 ~8 ~7 stone_brick_stairs[facing=west,half=top]
setblock ~6 ~8 ~-7 stone_brick_stairs[facing=east,half=top]
setblock ~7 ~8 ~-6 stone_brick_stairs[facing=north,half=top]
setblock ~-7 ~8 ~-6 stone_brick_stairs[facing=north,half=top]
setblock ~-6 ~8 ~-7 stone_brick_stairs[facing=west,half=top]

## Randomness
# Floor patterns
function dun:generate/random

## Roof
fill ~-8 ~9 ~-8 ~8 ~9 ~8 minecraft:gray_terracotta
fill ~-5 ~9 ~-6 ~5 ~9 ~6 minecraft:stone_bricks
fill ~-6 ~9 ~-5 ~6 ~9 ~5 minecraft:stone_bricks

## Randomness
# Roof patterns
function dun:generate/random

## Light
fill ~-7 ~ ~-7 ~7 ~9 ~7 minecraft:light[level=10] replace minecraft:air

## High Roof (to block the room from maps until discovered)
fill ~-8 ~20 ~-8 ~8 ~20 ~8 minecraft:gray_terracotta